Index: branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Improvers/SingleObjectiveTestFunctionImprovementOperator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Improvers/SingleObjectiveTestFunctionImprovementOperator.cs	(revision 13401)
+++ branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Improvers/SingleObjectiveTestFunctionImprovementOperator.cs	(revision 13403)
@@ -26,5 +26,4 @@
 using HeuristicLab.Encodings.RealVectorEncoding;
 using HeuristicLab.Operators;
-using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -40,5 +39,5 @@
   [Item("SingleObjectiveTestFunctionImprovementOperator", "An operator that improves test functions solutions. It is implemented as described in Laguna, M. and Martí, R. (2003). Scatter Search: Methodology and Implementations in C. Operations Research/Computer Science Interfaces Series, Vol. 24. Springer.")]
   [StorableClass]
-  public sealed class SingleObjectiveTestFunctionImprovementOperator : SingleSuccessorOperator, ISingleObjectiveImprovementOperator {
+  public sealed class SingleObjectiveTestFunctionImprovementOperator : SingleSuccessorOperator, ISingleObjectiveTestFunctionImprovementOperator {
     #region Parameter properties
     public IValueParameter<DoubleValue> AlphaParameter {
@@ -51,12 +50,9 @@
       get { return (IValueLookupParameter<DoubleMatrix>)Parameters["Bounds"]; }
     }
-    public ScopeParameter CurrentScopeParameter {
-      get { return (ScopeParameter)Parameters["CurrentScope"]; }
-    }
     public IValueParameter<DoubleValue> DeltaParameter {
       get { return (IValueParameter<DoubleValue>)Parameters["Delta"]; }
     }
-    public IValueLookupParameter<ISingleObjectiveTestFunctionProblemEvaluator> EvaluatorParameter {
-      get { return (IValueLookupParameter<ISingleObjectiveTestFunctionProblemEvaluator>)Parameters["Evaluator"]; }
+    public IValueLookupParameter<ISingleObjectiveTestFunction> TestFunctionParameter {
+      get { return (IValueLookupParameter<ISingleObjectiveTestFunction>)Parameters["TestFunction"]; }
     }
     public IValueParameter<DoubleValue> GammaParameter {
@@ -78,21 +74,9 @@
       get { return BetaParameter.Value; }
     }
-    private DoubleMatrix Bounds {
-      get { return BoundsParameter.ActualValue; }
-    }
-    public IScope CurrentScope {
-      get { return CurrentScopeParameter.ActualValue; }
-    }
     private DoubleValue Delta {
       get { return DeltaParameter.Value; }
     }
-    public ISingleObjectiveTestFunctionProblemEvaluator Evaluator {
-      get { return EvaluatorParameter.ActualValue; }
-    }
     private DoubleValue Gamma {
       get { return GammaParameter.Value; }
-    }
-    public IntValue ImprovementAttempts {
-      get { return ImprovementAttemptsParameter.ActualValue; }
     }
     #endregion
@@ -106,11 +90,10 @@
       Parameters.Add(new ValueParameter<DoubleValue>("Alpha", new DoubleValue(1.0)));
       Parameters.Add(new ValueParameter<DoubleValue>("Beta", new DoubleValue(2.0)));
+      Parameters.Add(new ValueParameter<DoubleValue>("Delta", new DoubleValue(0.5)));
+      Parameters.Add(new ValueParameter<DoubleValue>("Gamma", new DoubleValue(0.5)));
+      Parameters.Add(new ValueLookupParameter<ISingleObjectiveTestFunction>("TestFunction", "The operator used to evaluate solutions."));
       Parameters.Add(new ValueLookupParameter<DoubleMatrix>("Bounds", "The lower and upper bounds in each dimension."));
-      Parameters.Add(new ScopeParameter("CurrentScope", "The current scope that contains the solution to be improved."));
-      Parameters.Add(new ValueParameter<DoubleValue>("Delta", new DoubleValue(0.5)));
-      Parameters.Add(new ValueLookupParameter<ISingleObjectiveTestFunctionProblemEvaluator>("Evaluator", "The operator used to evaluate solutions."));
-      Parameters.Add(new ValueParameter<DoubleValue>("Gamma", new DoubleValue(0.5)));
       Parameters.Add(new ValueLookupParameter<IntValue>("ImprovementAttempts", "The number of improvement attempts the operator should perform.", new IntValue(100)));
-      Parameters.Add(new ValueLookupParameter<IItem>("Solution", "The solution to be improved. This parameter is used for name translation only."));
+      Parameters.Add(new ValueLookupParameter<IItem>("Solution", "The solution to be improved. This parameter is used for name translation only.")); // TODO: Problematic, this cannot be wired! IImprovementOperators need to be generic
       #endregion
     }
@@ -121,11 +104,13 @@
 
     public override IOperation Apply() {
-      RealVector bestSol = CurrentScope.Variables[SolutionParameter.ActualName].Value as RealVector;
+      RealVector bestSol = ExecutionContext.Scope.Variables[SolutionParameter.ActualName].Value as RealVector;
       if (bestSol == null)
         throw new ArgumentException("Cannot improve solution because it has the wrong type.");
 
-      var evaluator = Evaluator;
+      var bounds = BoundsParameter.ActualValue;
+      var function = TestFunctionParameter.ActualValue;
+      var maxIterations = ImprovementAttemptsParameter.ActualValue.Value;
 
-      double bestSolQuality = evaluator.Evaluate(bestSol);
+      double bestSolQuality = function.Evaluate(bestSol);
 
       // create perturbed solutions
@@ -133,13 +118,13 @@
       for (int i = 0; i < simplex.Length; i++) {
         simplex[i] = bestSol.Clone() as RealVector;
-        simplex[i][i] += 0.1 * (Bounds[0, 1] - Bounds[0, 0]);
-        if (simplex[i][i] > Bounds[0, 1]) simplex[i][i] = Bounds[0, 1];
-        if (simplex[i][i] < Bounds[0, 0]) simplex[i][i] = Bounds[0, 0];
+        simplex[i][i] += 0.1 * (bounds[0, 1] - bounds[0, 0]);
+        if (simplex[i][i] > bounds[0, 1]) simplex[i][i] = bounds[0, 1];
+        if (simplex[i][i] < bounds[0, 0]) simplex[i][i] = bounds[0, 0];
       }
 
       // improve solutions
-      for (int i = 0; i < ImprovementAttempts.Value; i++) {
+      for (int i = 0; i < maxIterations; i++) {
         // order according to their objective function value
-        Array.Sort(simplex, (x, y) => evaluator.Evaluate(x).CompareTo(evaluator.Evaluate(y)));
+        Array.Sort(simplex, (x, y) => function.Evaluate(x).CompareTo(function.Evaluate(y)));
 
         // calculate centroid
@@ -155,30 +140,30 @@
         for (int j = 0; j < reflectionPoint.Length; j++)
           reflectionPoint[j] = centroid[j] + Alpha.Value * (centroid[j] - simplex[simplex.Length - 1][j]);
-        double reflectionPointQuality = evaluator.Evaluate(reflectionPoint);
-        if (evaluator.Evaluate(simplex[0]) <= reflectionPointQuality
-            && reflectionPointQuality < evaluator.Evaluate(simplex[simplex.Length - 2]))
+        double reflectionPointQuality = function.Evaluate(reflectionPoint);
+        if (function.Evaluate(simplex[0]) <= reflectionPointQuality
+            && reflectionPointQuality < function.Evaluate(simplex[simplex.Length - 2]))
           simplex[simplex.Length - 1] = reflectionPoint;
 
         // expansion
-        if (reflectionPointQuality < evaluator.Evaluate(simplex[0])) {
+        if (reflectionPointQuality < function.Evaluate(simplex[0])) {
           RealVector expansionPoint = new RealVector(bestSol.Length);
           for (int j = 0; j < expansionPoint.Length; j++)
             expansionPoint[j] = centroid[j] + Beta.Value * (reflectionPoint[j] - centroid[j]);
-          simplex[simplex.Length - 1] = evaluator.Evaluate(expansionPoint) < reflectionPointQuality ? expansionPoint : reflectionPoint;
+          simplex[simplex.Length - 1] = function.Evaluate(expansionPoint) < reflectionPointQuality ? expansionPoint : reflectionPoint;
         }
 
         // contraction
-        if (evaluator.Evaluate(simplex[simplex.Length - 2]) <= reflectionPointQuality
-            && reflectionPointQuality < evaluator.Evaluate(simplex[simplex.Length - 1])) {
+        if (function.Evaluate(simplex[simplex.Length - 2]) <= reflectionPointQuality
+            && reflectionPointQuality < function.Evaluate(simplex[simplex.Length - 1])) {
           RealVector outsideContractionPoint = new RealVector(bestSol.Length);
           for (int j = 0; j < outsideContractionPoint.Length; j++)
             outsideContractionPoint[j] = centroid[j] + Gamma.Value * (reflectionPoint[j] - centroid[j]);
-          if (evaluator.Evaluate(outsideContractionPoint) <= reflectionPointQuality) {
+          if (function.Evaluate(outsideContractionPoint) <= reflectionPointQuality) {
             simplex[simplex.Length - 1] = outsideContractionPoint;
-            if (evaluator.Evaluate(reflectionPoint) >= evaluator.Evaluate(simplex[simplex.Length - 1])) {
+            if (function.Evaluate(reflectionPoint) >= function.Evaluate(simplex[simplex.Length - 1])) {
               RealVector insideContractionPoint = new RealVector(bestSol.Length);
               for (int j = 0; j < insideContractionPoint.Length; j++)
                 insideContractionPoint[j] = centroid[j] - Gamma.Value * (reflectionPoint[j] - centroid[j]);
-              if (evaluator.Evaluate(insideContractionPoint) < evaluator.Evaluate(simplex[simplex.Length - 1])) simplex[simplex.Length - 1] = insideContractionPoint;
+              if (function.Evaluate(insideContractionPoint) < function.Evaluate(simplex[simplex.Length - 1])) simplex[simplex.Length - 1] = insideContractionPoint;
             }
           }
@@ -192,10 +177,10 @@
 
       for (int i = 0; i < simplex[0].Length; i++) {
-        if (simplex[0][i] > Bounds[0, 1]) simplex[0][i] = Bounds[0, 1];
-        if (simplex[0][i] < Bounds[0, 0]) simplex[0][i] = Bounds[0, 0];
+        if (simplex[0][i] > bounds[0, 1]) simplex[0][i] = bounds[0, 1];
+        if (simplex[0][i] < bounds[0, 0]) simplex[0][i] = bounds[0, 0];
       }
 
-      CurrentScope.Variables[SolutionParameter.ActualName].Value = simplex[0];
-      CurrentScope.Variables.Add(new Variable("LocalEvaluatedSolutions", ImprovementAttempts));
+      ExecutionContext.Scope.Variables[SolutionParameter.ActualName].Value = simplex[0];
+      ExecutionContext.Scope.Variables.Add(new Variable("LocalEvaluatedSolutions", new IntValue(maxIterations)));
 
       return base.Apply();
Index: branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Instances/SOTFData.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Instances/SOTFData.cs	(revision 13401)
+++ branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Instances/SOTFData.cs	(revision 13403)
@@ -39,5 +39,5 @@
     /// The operator used for evaluations
     /// </summary>
-    public ISingleObjectiveTestFunctionProblemEvaluator Evaluator { get; set; }
+    public ISingleObjectiveTestFunction TestFunction { get; set; }
   }
 }
Index: branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Instances/SOTFDataDescriptor.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Instances/SOTFDataDescriptor.cs	(revision 13401)
+++ branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Instances/SOTFDataDescriptor.cs	(revision 13403)
@@ -24,14 +24,14 @@
 namespace HeuristicLab.Problems.TestFunctions {
   internal class SOTFDataDescriptor : IDataDescriptor {
-    public string Name { get { return Evaluator.FunctionName + " Function"; } }
+    public string Name { get { return TestFunction.ItemName + " Function"; } }
 
     public string Description {
-      get { return Evaluator.Description; }
+      get { return TestFunction.Description; }
     }
 
-    internal ISingleObjectiveTestFunctionProblemEvaluator Evaluator { get; set; }
+    internal ISingleObjectiveTestFunction TestFunction { get; set; }
 
-    public SOTFDataDescriptor(ISingleObjectiveTestFunctionProblemEvaluator evaluator) {
-      Evaluator = evaluator;
+    public SOTFDataDescriptor(ISingleObjectiveTestFunction testFunction) {
+      TestFunction = testFunction;
     }
   }
Index: branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Instances/SOTFInstanceProvider.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Instances/SOTFInstanceProvider.cs	(revision 13401)
+++ branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Instances/SOTFInstanceProvider.cs	(revision 13403)
@@ -45,5 +45,5 @@
 
     public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
-      var evaluators = ApplicationManager.Manager.GetInstances<ISingleObjectiveTestFunctionProblemEvaluator>()
+      var evaluators = ApplicationManager.Manager.GetInstances<ISingleObjectiveTestFunction>()
                                                  .OrderBy(x => x.Name);
       return evaluators.Select(x => new SOTFDataDescriptor(x));
@@ -55,5 +55,5 @@
         Name = descriptor.Name,
         Description = descriptor.Description,
-        Evaluator = descriptor.Evaluator
+        TestFunction = descriptor.TestFunction
       };
     }
Index: branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Interfaces/IBestSingleObjectiveTestFunctionSolutionAnalyzer.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Interfaces/IBestSingleObjectiveTestFunctionSolutionAnalyzer.cs	(revision 13401)
+++ branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Interfaces/IBestSingleObjectiveTestFunctionSolutionAnalyzer.cs	(revision 13403)
@@ -21,4 +21,6 @@
 
 using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.RealVectorEncoding;
 using HeuristicLab.Optimization;
 
@@ -27,7 +29,7 @@
   /// An interface which represents operators for analyzing the best solution of single objective TestFunction Problems given in real vector representation.
   /// </summary>
-  public interface IBestSingleObjectiveTestFunctionSolutionAnalyzer : IAnalyzer, ISingleObjectiveOperator {
-    ILookupParameter RealVectorParameter { get; }
-    ILookupParameter QualityParameter { get; }
+  public interface IBestSingleObjectiveTestFunctionSolutionAnalyzer : IAnalyzer, ISingleObjectiveOperator,
+    IRealVectorSolutionsOperator, IRealVectorBoundedOperator {
+    IScopeTreeLookupParameter<DoubleValue> QualityParameter { get; }
     ILookupParameter<SingleObjectiveTestFunctionSolution> BestSolutionParameter { get; }
     IValueLookupParameter<ResultCollection> ResultsParameter { get; }
Index: branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Interfaces/ISingleObjectiveTestFunction.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Interfaces/ISingleObjectiveTestFunction.cs	(revision 13403)
+++ branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Interfaces/ISingleObjectiveTestFunction.cs	(revision 13403)
@@ -0,0 +1,41 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.RealVectorEncoding;
+
+namespace HeuristicLab.Problems.TestFunctions {
+  /// <summary>
+  /// An interface which represents an evaluation operator for single objective test functions.
+  /// </summary>
+  public interface ISingleObjectiveTestFunction : INamedItem {
+    bool Maximization { get; }
+    DoubleMatrix Bounds { get; }
+    double BestKnownQuality { get; }
+    int MinimumProblemSize { get; }
+    int MaximumProblemSize { get; }
+
+    double Evaluate2D(double x, double y);
+    double Evaluate(RealVector point);
+    RealVector GetBestKnownSolution(int dimension);
+  }
+}
Index: branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Interfaces/ISingleObjectiveTestFunctionAdditiveMoveEvaluator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Interfaces/ISingleObjectiveTestFunctionAdditiveMoveEvaluator.cs	(revision 13401)
+++ branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Interfaces/ISingleObjectiveTestFunctionAdditiveMoveEvaluator.cs	(revision 13403)
@@ -23,5 +23,5 @@
 
 namespace HeuristicLab.Problems.TestFunctions {
-  public interface ISingleObjectiveTestFunctionAdditiveMoveEvaluator : ISingleObjectiveTestFunctionMoveEvaluator, IAdditiveRealVectorMoveOperator {
+  public interface ISingleObjectiveTestFunctionAdditiveMoveEvaluator : ISingleObjectiveTestFunctionMoveEvaluator, IRealVectorAdditiveMoveOperator {
   }
 }
Index: branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Interfaces/ISingleObjectiveTestFunctionMoveEvaluator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Interfaces/ISingleObjectiveTestFunctionMoveEvaluator.cs	(revision 13401)
+++ branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Interfaces/ISingleObjectiveTestFunctionMoveEvaluator.cs	(revision 13403)
@@ -20,10 +20,8 @@
 #endregion
 
-using System;
 using HeuristicLab.Optimization;
 
 namespace HeuristicLab.Problems.TestFunctions {
   public interface ISingleObjectiveTestFunctionMoveEvaluator : ISingleObjectiveMoveEvaluator, IMoveOperator {
-    Type EvaluatorType { get; }
   }
 }
Index: branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Interfaces/ISingleObjectiveTestFuntionImprovementOperator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Interfaces/ISingleObjectiveTestFuntionImprovementOperator.cs	(revision 13403)
+++ branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Interfaces/ISingleObjectiveTestFuntionImprovementOperator.cs	(revision 13403)
@@ -0,0 +1,28 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Problems.TestFunctions {
+  public interface ISingleObjectiveTestFunctionImprovementOperator : ISingleObjectiveImprovementOperator, IRealVectorBoundedOperator {
+  }
+}
Index: branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Interfaces/ITestFunctionSolutionSimilarityCalculator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Interfaces/ITestFunctionSolutionSimilarityCalculator.cs	(revision 13403)
+++ branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/Interfaces/ITestFunctionSolutionSimilarityCalculator.cs	(revision 13403)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Problems.TestFunctions {
+  public interface ITestFunctionSolutionSimilarityCalculator : ISolutionSimilarityCalculator {
+    DoubleMatrix Bounds { get; set; }
+  }
+}
Index: branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/MoveEvaluators/AdditiveMoveEvaluator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/MoveEvaluators/AdditiveMoveEvaluator.cs	(revision 13401)
+++ branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/MoveEvaluators/AdditiveMoveEvaluator.cs	(revision 13403)
@@ -20,5 +20,4 @@
 #endregion
 
-using System;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -32,7 +31,6 @@
   [Item("AdditiveMoveEvaluator", "Base class for evaluating an additive move.")]
   [StorableClass]
-  public abstract class AdditiveMoveEvaluator : SingleSuccessorOperator, ISingleObjectiveTestFunctionAdditiveMoveEvaluator {
+  public class AdditiveMoveEvaluator : SingleSuccessorOperator, ISingleObjectiveTestFunctionAdditiveMoveEvaluator {
 
-    public abstract Type EvaluatorType { get; }
     public override bool CanChangeName {
       get { return false; }
@@ -51,9 +49,12 @@
       get { return (ILookupParameter<AdditiveMove>)Parameters["AdditiveMove"]; }
     }
+    public ILookupParameter<ISingleObjectiveTestFunction> TestFunctionParameter {
+      get { return (ILookupParameter<ISingleObjectiveTestFunction>)Parameters["TestFunction"]; }
+    }
 
     [StorableConstructor]
     protected AdditiveMoveEvaluator(bool deserializing) : base(deserializing) { }
     protected AdditiveMoveEvaluator(AdditiveMoveEvaluator original, Cloner cloner) : base(original, cloner) { }
-    protected AdditiveMoveEvaluator()
+    public AdditiveMoveEvaluator()
       : base() {
       Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality of a test function solution."));
@@ -61,9 +62,21 @@
       Parameters.Add(new LookupParameter<RealVector>("Point", "The point to evaluate the move on."));
       Parameters.Add(new LookupParameter<AdditiveMove>("AdditiveMove", "The move to evaluate."));
+      Parameters.Add(new LookupParameter<ISingleObjectiveTestFunction>("TestFunction", "The test function that is used."));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new AdditiveMoveEvaluator(this, cloner);
     }
 
     public override IOperation Apply() {
-      double mq = Evaluate(QualityParameter.ActualValue.Value, RealVectorParameter.ActualValue, AdditiveMoveParameter.ActualValue);
-      DoubleValue moveQuality = MoveQualityParameter.ActualValue;
+      var function = TestFunctionParameter.ActualValue;
+      var move = AdditiveMoveParameter.ActualValue;
+      var vector = RealVectorParameter.ActualValue;
+      var clone = (RealVector)vector.Clone();
+
+      AdditiveMoveMaker.Apply(clone, move);
+      var mq = function.Evaluate(clone);
+
+      var moveQuality = MoveQualityParameter.ActualValue;
       if (moveQuality == null) {
         MoveQualityParameter.ActualValue = new DoubleValue(mq);
@@ -71,6 +84,4 @@
       return base.Apply();
     }
-
-    protected abstract double Evaluate(double quality, RealVector point, AdditiveMove move);
   }
 }
Index: branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/SimilarityCalculators/SingleObjectiveTestFunctionSimilarityCalculator.cs
===================================================================
--- branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/SimilarityCalculators/SingleObjectiveTestFunctionSimilarityCalculator.cs	(revision 13401)
+++ branches/ProblemRefactoring/HeuristicLab.Problems.TestFunctions/3.3/SimilarityCalculators/SingleObjectiveTestFunctionSimilarityCalculator.cs	(revision 13403)
@@ -37,5 +37,5 @@
   [Item("SingleObjectiveTestFunctionSimilarityCalculator", "An operator that performs similarity calculation between two test functions solutions. The operator calculates the similarity based on the euclidean distance of the two solutions in n-dimensional space.")]
   [StorableClass]
-  public sealed class SingleObjectiveTestFunctionSimilarityCalculator : SingleObjectiveSolutionSimilarityCalculator {
+  public sealed class SingleObjectiveTestFunctionSimilarityCalculator : SingleObjectiveSolutionSimilarityCalculator, ITestFunctionSolutionSimilarityCalculator {
     protected override bool IsCommutative { get { return true; } }
 
